import { LitElement, PropertyValueMap } from 'lit';
import { InputData } from './definition-schema.js';
type Theme = {
    theme_name: string;
    theme_object: any;
};
export declare class WidgetValue extends LitElement {
    inputData?: InputData;
    theme?: Theme;
    private dataSets;
    private textActive;
    private themeBgColor?;
    private themeTitleColor?;
    private themeSubtitleColor?;
    version: string;
    private resizeObserver;
    valueContainer?: HTMLDivElement;
    boxes?: HTMLDivElement[];
    origWidth: number;
    origHeight: number;
    constructor();
    disconnectedCallback(): void;
    protected firstUpdated(_changedProperties: PropertyValueMap<any> | Map<PropertyKey, unknown>): void;
    update(changedProperties: Map<string, any>): void;
    registerTheme(theme?: Theme): void;
    sizingSetup(): void;
    applyData(): void;
    transformData(): Promise<void>;
    static styles: import("lit").CSSResult;
    render(): import("lit-html").TemplateResult<1>;
}
export {};
